#include <stdio.h>
#include <stdlib.h>
#include "readline.h"

/* read a line of arbitrary length from fp and
   return a pointer to a dynamically allocated array
   with the line contents (excluding the terminating '\n');
   return 0 in case of eof or if no memory was available
*/
char* readline(FILE* fp) {
   int len = 32;
   char* cp = malloc(len);
   if (!cp) return 0;
   int i = 0;
   int ch;
   while ((ch = getc(fp)) != EOF && ch != '\n') {
      cp[i++] = ch;
      if (i == len) {
	 /* double the allocated space */
	 len *= 2;
	 char* newcp = realloc(cp, len);
	 if (!newcp) {
	    free(cp);
	    return 0;
	 }
	 cp = newcp;
      }
   }
   if (i == 0 && ch == EOF) {
      free(cp);
      return 0;
   }
   cp[i++] = 0;
   return realloc(cp, i); /* free unused space */
}
